require 'active_support/core_ext'
require 'mechanize'
require 'multi_json'
require 'round_robin'

require 'ozon_parser/version'
require 'ozon_parser/config'
require 'ozon_parser/agent'
require 'ozon_parser/proxy'
require 'ozon_parser/proxy_list'

require 'ozon_parser/page'
require 'ozon_parser/pages/base'
require 'ozon_parser/pages/book'

module OzonParser
	Encoding.default_external = Encoding::UTF_8

	def self.configure
    	@config = OzonParser::Config.new
    	yield @config
  	end

  	def self.config
    	@config ||= OzonParser::Config.new
  	end

  	def self.config_reset
    	@config = OzonParser::Config.new
  	end

  	class BaseError < StandardError
  	end

  	class TypeError < BaseError
  	end

  	class DecodeError < BaseError
  	end

    class ConnectionError < BaseError
    end

    class InitError < BaseError
    end

end