module OzonParser
  module Pages
    class Base < OzonParser::Page
      attr_accessor :id, :url


      # This method need to point url source of page
      # @return [String] url
      def parse_url(id)
        BASE_OZON_URL + "/context/detail/id/#{id}/"
      end

      def initialize(args = {})

        @source = args.delete(:source)
        @url= args.delete(:url)
        @id= args.delete(:id)

        args.each do |k,v|
          instance_variable_set("@#{k}", v) unless v.nil?
        end

        return super(source: @source) if @source
        return super(url: @url) if @url
        raise InitError if @id.nil?
        @url = parse_url(@id)
        super(url: @url)
      end
    end
  end
end