module OzonParser
  module Pages
    class Book < Base

      field :categories do      
        cats = root.xpath('//ul[@class="navLine"]/li')
        cats.map &:text
      end

      field :title do
        categories.last
      end

      field :type do
        categories.first
      end      

      field :cover_url do
        dirty = root.xpath('//img[@class="eMicroGallery_fullImage"]/@src').try(:text)
        if dirty
          clean = dirty.split('/').map{|x| x if x.present? && x != "c300"}.compact.join("/")
          "http://" + clean
        end
      end

      field :cover_file do
        try(:file, cover_url)
      end

      field :tags do
        categories - [title, type]
      end

      field :author do
        dirty = root.xpath('//div[@class="bGeneralProperties"]/p[@itemprop="author"]/a/@title').try(:text)
      end
      
      field :language do
        dirty = root.xpath('//div[@class="bGeneralProperties"]/p[@itemprop="inLanguage"]').try(:text)
          if dirty 
              clean = dirty.gsub("Языки:","")
              clean.split(",").map &:strip
          end
      end

      field :isbn do
        dirty = root.xpath('//div[@class="bGeneralProperties"]/p[@itemprop="isbn"]').try(:text)
        if dirty
          numbers_with_year = dirty.gsub("ISBN ", "")
          numbers = numbers_with_year.split(";").first
          numbers.split(",").map &:strip
        end
      end

      field :pages do
        dirty = root.xpath('//div[@class="bTechCover "]/div[@class="bTechDescr"]/span[@itemprop="numberOfPages"]').try(:text)
        if dirty 
          dirty.to_i
        end
      end

    end
  end
end
